<?xml version="1.0" encoding="UTF-8"?>
<!-- created on 18 février 2004	-->
<!-- last modified on 14 mai 2004	-->
<xsl:stylesheet version="1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xf="http://www.w3.org/2002/xforms" xmlns:xhtml="http://www.w3.org/2002/06/xhtml2" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:fo="http://www.w3.org/1999/XSL/Format">
	<!-- importe la correspondance entre les différents types d'éléments et leur représentation xforms -->
	<xsl:import href="look.xsl"/>
	<xsl:output method="xml" version="1.0" encoding="iso-8859-1" indent="yes"/>
	<!--_________________________________________________________________________________________________________STRUCTURE DU DOCUMENT _______________________________ -->
	<!-- crée la structure du document et y insère les différentes parties -->
	<xsl:template match="/">
		<html>
			<head>
				<title>Prototype</title>
				<!--_________________________________________________________gestion des styles__________________________ -->
				<style type="text/css">
					.element_terminal {background-color : #ddddff;}
					.element_non_terminal {background-color : #9999dd;}
					.attribut {background-color : #ddfdde;}
					.bouton_masque_arborescence {margin-right:1.5:mm;}
				</style>
				<xf:model id="model">
					<xf:instance id="instance"/>
					<xf:submission method="put" includenamespaceprefixes="" action="" id="bValider" replace="none"/>
				</xf:model>
				<!--_________________________________________________________fonctions de masquage des noeuds____________ -->
				<script type="text/javascript">
					/**
					* modifie l'état (visible ou maqué) d'un objet, et modifie l'apparance du bouton en charge de cette action
					* @param id_bouton_masque identifiant du bouton
					* @param id_bloc_fils identifiant du bloc à masquer
					*/
					function change_visiblity(id_bouton_masque, id_bloc_fils)
					{
						bloc_fils=document.getElementById(id_bloc_fils);
						bouton_masque=document.getElementById(id_bouton_masque);
						if (bloc_fils.style.display=='none') 	// les éléments fils sont cachés
						{
							bloc_fils.style.display='';			// reaffiche le bloc
							bouton_masque.innerHTML="-";	// change le contenu du bouton en "moins"
						} 
						else								// les éléments fils sont visible
						{
							bloc_fils.style.display='none';	// cache le bloc
							bouton_masque.innerHTML="+";	// change le contenu du bouton en "plus"
						}
					}
				</script>
			</head>
			<xhtml:body>
				<!--_________________________________________________________création de du formulaire : imbrication des tables__ -->


				<xsl:apply-templates/>
				<table align="center">
					<tr>
						<td align="center">
							<xf:submit submission="bValider">
								<xf:label>Valider les modifications</xf:label>
							</xf:submit>
						</td>
					</tr>
				</table>
			</xhtml:body>
		</html>
	</xsl:template>
	<!--__________________________________________________________________________________________________________ GESTION DES ATTRIBUTS______________________________ -->
	<!-- affiche dans une table  tous les attributs d'un élément de l'arbre -->
	<xsl:template name="gestion_attributs">
		<xsl:param name="param_id"/>
		<xsl:if test="count(attribute::*)!=0	">
			<!-- si l'élément possède des attributs, on crée une sous table pour les insérer -->
			<tr id="{$param_id}">
				<!-- donne un identificateur à la table des attributs pour pouvoir la masquer -->
				<td colspan="2">
					<!-- colspan ="2" car dans le cas où on ajoute les attributs à un élément terminal, il y a deux colonnes dans la table (element, value) -->
					<table style="width:100%" border="0">
						<xsl:for-each select="attribute::*">
							<!-- pour chaque attribut de l'élément, on ajoute une ligne dans la table, la ligne contient deux cases -->
							<tr>
								<td class="attribut" width="50%">
									<!-- une case qui contient le nom de l'attribut -->
									<xsl:value-of select="name(current())"/>
								</td>
								<td>
									<xsl:call-template name="look">
										<xsl:with-param name="reference">
											<xsl:for-each select="ancestor::*"><xsl:text>/*[</xsl:text><xsl:value-of select="1+count(preceding-sibling::*)"/><xsl:text>]</xsl:text></xsl:for-each><xsl:text>/@</xsl:text><xsl:value-of select="name(current())"/>
										</xsl:with-param>
									</xsl:call-template>
								</td>
							</tr>
						</xsl:for-each>
					</table>
				</td>
			</tr>
		</xsl:if>
	</xsl:template>
	<!--_________________________________________________________________________________________________________CREATION D'UN ELEMENT DE LA TABLE_(+récusion sur les fils)____ -->
	<!-- parcours récursivement tous les éléments de l'abre en créeant leur vue -->
	<xsl:template match="*">
 	   <xsl:if test="name(current())='property'">
		<xsl:apply-templates/>
	   </xsl:if>
	   <xsl:if test="not(name(current())='property')">
		<xsl:variable name="id" select="generate-id()"/>
		<!-- crée un idenfiant pour l'élément : c'est utile pour masquer ses fils et attributs -->
		<table style="width:100%" border="0">
			<xsl:choose>
				<!-- on différencie deux types d'éléments :  -->
				<!-- 		- un élément terminal qui est une feuille de l'arbre, il n'a pas d'élément fils, il peut avoir des attributs, et peut contenir une valeur -->
				<!--		- un élément non terminal qui est un noeud de l'arbre, il possède des éléments fils, il peut avoir des attriburs, et ne contient pas de valeur -->
				<!-- _____________________________________________________ CAS D'UN ELEMENT TERMINAL_______________-->
				<xsl:when test="count(child::*) = 0">
				   <!-- l'élément n'a pas de fils, c'est un élement terminal : une feuille  -->
				   <xsl:if test="not(name(current())='name' and name(parent::node())='property')">
					<tr>
						<!-- gestion de l'action pour maquer le contenu -->
						<xsl:if test="count(attribute::*)>0">
							<!-- on  vérifie qu'il y a quelque chose à masquer -->
							<xsl:attribute name="onclick">change_visiblity('<xsl:value-of select="$id"/>_bouton_masque', '<xsl:value-of select="$id"/>');</xsl:attribute>
							<xsl:attribute name="style">cursor:pointer</xsl:attribute>
						</xsl:if>
						<!-- affichage du nom de l'élément -->
						<td class="element_terminal" width="50%">
							<xsl:if test="count(attribute::*)>0">
								<!--si  l'élément terminal possède des attributs : on affiche  le bouton  pour les cacher -->
								<span class="bouton_masque_arborescence" id="{$id}_bouton_masque">-</span>
							</xsl:if>
							<xsl:if test="name(current())='value' and name(parent::node())='property'">
								<xsl:value-of select="parent::node()/name"/>
		  				        </xsl:if>
							<xsl:if test="not(name(current())='value' and name(parent::node())='property')">
								<xsl:value-of select="name(current())"/>
		  				        </xsl:if>
						</td>
						<td>
							<xsl:call-template name="look">
								<xsl:with-param name="reference">
									<xsl:for-each select="ancestor-or-self::*"><xsl:text>/*[</xsl:text><xsl:value-of select="1+count(preceding-sibling::*)"/><xsl:text>]</xsl:text></xsl:for-each>
								</xsl:with-param>
							</xsl:call-template>
						</td>		
					</tr>
				   </xsl:if>
					<!-- gestion de l'affichage des attributs de l'élément : on ajoute à la suite une ligne contenant une table avec tous ces attributs -->
					<xsl:call-template name="gestion_attributs">
						<xsl:with-param name="param_id" select="$id"/>
						<!-- on passe en paramètre l'identifiant de l'élément -->
					</xsl:call-template>
				</xsl:when>
				<!--_____________________________________________________ CAS D'UN NOEUD___________________________ -->
				<xsl:otherwise>
					<tr>
						<!--______________prend en charge le masquage des éléments fis ou attribut_______________-->
						<xsl:if test="(count(child::*)+count(attribute::*))>0">
							<!-- le noeud possède au moins un élément fils ou au moins un attribut; dans ce cas on permet de les cacher -->
							<xsl:attribute name="onclick">
								change_visiblity('<xsl:value-of select="$id"/>_bouton_masque', '<xsl:value-of select="$id"/>');
							</xsl:attribute>
							<xsl:attribute name="style">cursor:pointer</xsl:attribute>
						</xsl:if>
						<!-- affiche le nom de l'élément -->
						<td class="element_non_terminal" colspan="2">
							<xsl:if test="(count(child::*)+count(attribute::*))>0">
								<!-- si il y a quelque chose à masquer, on affiche le bouton (+/-)-->
								<span class="bouton_masque_arborescence" id="{$id}_bouton_masque">-</span>
							</xsl:if>
							<xsl:value-of select="name(current())"/>
							<!-- le nom de l'élément -->
						</td>
					</tr>
					<!-- on crée une table qui contient tous les attributs du noeud ainsi que tous les éléments fils -->
					<tr id="{$id}">
						<!-- on identifie le bloc pour pouvoir le masquer -->
						<td>
							<table style="width:100%" border="0">
								<!-- gestion des attributs du noeud -->
								<xsl:call-template name="gestion_attributs">
									<xsl:with-param name="param_id" select="$id"/>
								</xsl:call-template>
								<!-- gestion des fils du noeud -->
								<tr>
									<td>
										<xsl:apply-templates/>
										<!-- appel récursif sur tous les élements fils du noeud-->
									</td>
								</tr>
							</table>
						</td>
					</tr>
				</xsl:otherwise>
			</xsl:choose>
		</table>
 	   </xsl:if>
	</xsl:template>
</xsl:stylesheet>
