package hero.client.test;

import hero.interfaces.*;
import junit.framework.*;
import java.util.*;

public class DbReset extends TestCase {

	private BnUserHome uhome;
	private BnAuthRoleHome arhome;
	private BnProjectHome pHome;
        private BnUserHome uHome;
        private BnAuthRoleHome aHome;

	public DbReset(String testname) {
	super(testname);
	}
    
	public static TestSuite suite() {

	return new TestSuite(DbReset.class);
	}

	public void setUp() throws Exception {
	}

	public void testDbReset() throws Exception {
	   
	    // Get all projects and remove them.
	    pHome = hero.interfaces.BnProjectUtil.getHome();
	    Collection projects = pHome.findAll();
	    Iterator pr = projects.iterator();
	    while (pr.hasNext())
	    {
		BnProject project = (BnProject)pr.next(); 
		project.remove();
	    }

	    // Get all users and remove them.
	    uHome = hero.interfaces.BnUserUtil.getHome();
	    Collection users = uHome.findAll();
	    Iterator ur = users.iterator();
	    while (ur.hasNext())
	    {
		BnUser user = (BnUser)ur.next(); 
		user.remove();
	    }

	    // Get all AuthRole and remove them.
	    aHome = hero.interfaces.BnAuthRoleUtil.getHome();
	    Collection auths = aHome.findAll();
	    Iterator au = auths.iterator();
	    while (au.hasNext())
	    {
		BnAuthRole auth = (BnAuthRole)au.next(); 
		auth.remove();
	    }
            
	    
	    // Init default users and authRoles 
	    InsertAuthRoleUserHome lHome = InsertAuthRoleUserUtil.getHome(); 
	    InsertAuthRoleUser lBean = (InsertAuthRoleUser) lHome.create();
	    lBean.initializeUser(2,"admin","toto","toxic@loria.fr");
	    lBean.initializeUser(20,"admin2","toto2","toxic@loria.fr");
	    lBean.initializeUser(3,"nobody","nobody","toxic@loria.fr");
	    lBean.initializeAuthRole(2,"Admin","Admin");
	    lBean.initializeAuthRole(3,"nobody","nobody");
	    lBean.initialize("admin","Admin");
	    lBean.initialize("admin","nobody");
	    lBean.initialize("admin2","Admin");
	    lBean.initialize("admin2","nobody");
	    lBean.initialize("nobody","nobody");

	}
}
